/**Quality Thermistor, Inc.
 * USB Thermistor Input Device
 * QTI_USB_TempView.java
 * version tracking information
 * 1.01 basic functionality
 * 1.02 plotting
 * 1.03 data logging
 * 1.04 attempted tray icon, fix new USBUART incompatibility.
 * 1.05 added comment field for data logging and fixed time stamp
 * 1.06 changed measure and stream menu items to radio buttons and fixed temperature unit in log file
 * 1.07 added kelvin measurement temperature and added about box data sheet and troubleshooter's guide buttons
 */
package Measure;

//import RedFish_EZDegree.*;
import org.jdesktop.application.Action;
//import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
//import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;
//import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFrame;
import java.io.*;
import java.io.File;
import gnu.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.lang.*;
import java.text.*;
//import java.text.Format;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JPanel;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.XYPlot;
import org.jfree.data.time.Millisecond;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.data.xy.XYDataset;
//import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;
import java.awt.AWTException;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.SystemTray;
import java.awt.TrayIcon;
import java.awt.image.BufferedImage;

/**
 * The application's main frame.
 */
class DIRECTEMP_View extends FrameView implements Runnable, SerialPortEventListener {
//class QTI_USB_TempView extends JFrame implements Runnable, SerialPortEventListener {
    public InputStream is = null;
    public SerialPort myPort;
    public OutputStream oS;
    static BufferedReader reader;
    static String tempString;
    static String out1 = "3";
    static Thread readThread;
    public SerialPortSelect PC;
    public CommPortIdentifier thePortID;
    static CommPort thePort;
    static Timer readTimer;
    static File filename;
    static FileOutputStream fo;
    static PrintStream ps;
    static Integer uNits;
    static String header;
    static Integer totalTime;
    static LineChart plot;
    static Integer plotData;
    static Integer portReset;
    static Integer trayIsThere;
    static TraysIcon tray1;
    static String uNit;

    public DIRECTEMP_View(SingleFrameApplication app) {
        super(app);
        initComponents(); // Init components on graph panel (automatic)
        PC = new SerialPortSelect(null); // create port chooser window
        RefineryUtilities.centerFrameOnScreen(PC);
        PC.setVisible(true); // show port chooser window
        jlComPort.setText(PC.getSelectedName()); // set com port name in panel
        //System.out.println(jlComPort.getText());
        jLogFileName.setVisible(false);
        jtfFileName.setVisible(false);
        jLogging.setVisible(false);
        thePortID = PC.getSelectedIdentifier();
        //System.out.println(thePortID.toString());
        uNits = 0; // 0 is C, 1 is F, 2 is K;
        uNit = "C";
        plotData = 0;
        //tray1 = new TraysIcon();
        //plot = null;
//        jtaInput.append("uNits = " + uNits.toString() + " (C),default \n");
        mainPanel.setName("DIRECTEMP(TM) Probe Input");
        //mainPanel.setPreferredSize(385,340);
        //set up serial port
        try {
            thePort = thePortID.open("sysDataComm", 30000);
            myPort = (SerialPort) thePort;
//            jtaInput.append("Serial Port Activated\n");
        } catch (PortInUseException e) {
        }
        try {
            is = myPort.getInputStream();
        //          jtaInput.append("SerialPort Input selected\n");
        } catch (IOException e) {
        }
        try {
            // get the outputstream
            oS = myPort.getOutputStream();
        //jtaInput.append("SerialPort Output selected\n");
        } catch (IOException e) {
        }
        try {
            myPort.addEventListener(this);
        } catch (TooManyListenersException e) {
            System.out.println("error 3");
        }
        ActionListener listener = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int modifiers = e.getModifiers();

                JFrame source1 = (JFrame) e.getSource();
               
                JRadioButton source = (JRadioButton) e.getSource();
                //jtaInput.append(e.getActionCommand().toString() + "\n");

                JCheckBox source2 = (JCheckBox) e.getSource();
                //jtaInput.append(e.getActionCommand().toString() + "\n");

                
                //System.out.println("OK");
                //jtaInput.append("ok\n");

                Timer source3 = (Timer) e.getSource();
                //jtaInput.append(e.getActionCommand().toString() + "\n");
                //Timer timer = new Timer(500, actionListener);
                if (source1 != null) {
                //
                }
            }
            private boolean checkMod(int modifiers, int mask) {
                return ((modifiers & mask) == mask);
            }
        };
        myPort.notifyOnDataAvailable(true);
        try {
            myPort.setSerialPortParams(9600, SerialPort.DATABITS_8, SerialPort.STOPBITS_1,
                    SerialPort.PARITY_NONE);
        } catch (UnsupportedCommOperationException e) {
        }
        readTimer = new Timer(10, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Single();
            //jtaInput.append("Timer Fired\n");
            }
        });
        readThread = new Thread(this);
        readThread.start();
        TimeDelay(null);
    }
    /** Runs the thread to read the input buffer
     *  thread sleep number is the delay between reads...
     */
    public void run() {
        try {
            //for testing 
            Thread.sleep(100);
            //System.out.println("thread operation");
        //if (portReset == 1){
        //    return;
        //Thread.State.valueOf() = Terminated;
        //}
        //for testing 
        } catch (InterruptedException e) {
            System.out.println("error 5");
        }
    }
    /** Serial Event checks for the serial port input characters and updates the fields or the icon
     *  checks for unit and converts if necessary
     *  checks max and min and updates if necessary
     *  checks to see if form is minimized and redraws icon if necessary
     *  need to create catch event on form minimize... HIDE
     *  put in the tray and update on serial event.  double click on icon for reinstate
     *  
     * @param event
     */
    public void restoreForm() {
        mainPanel.setVisible(true);
        //tray1.removeIcon();
    }
    public void serialEvent(SerialPortEvent event) {
        Double currMax;
        Double currMin;
        Double value;
                        
        switch (event.getEventType()) {
            case SerialPortEvent.BI:
            case SerialPortEvent.OE:
            case SerialPortEvent.FE:
            case SerialPortEvent.PE:
            case SerialPortEvent.CD:
            case SerialPortEvent.CTS:
            case SerialPortEvent.DSR:
            case SerialPortEvent.RI:
            case SerialPortEvent.OUTPUT_BUFFER_EMPTY:
                break;
            case SerialPortEvent.DATA_AVAILABLE:
                //System.out.print("Data Available:");
                try {
                    reader = new BufferedReader(new InputStreamReader(is));
                    while (reader.ready()) {
                        String currLine = reader.readLine();
                        //System.out.println(currLine.toString());
                        try {
                            //Change this code to use the Split() function
                            StringTokenizer st = new StringTokenizer(currLine, "\n");
                            tempString = st.nextToken();
                            //for testing System.out.println(currLine);
                            //check value of first token in currLine assign to variable                      
                            //System.out.println(currLine.toString());
                            //jtaInput.append(tempString + "\n");
                            value = Double.parseDouble(tempString);
                            tempString = tempString + 0.005;
                            DecimalFormat df= new DecimalFormat("0.##");
                            //String text=df.Format(tempString);
                            if (uNits == 1){
                                value = ((value * 9 / 5) + 32);
                            }else{
                                if (uNits == 2){
                                    value = (value + 273.15);
                                }
                            }
                            if (value >= 100) {
                                tempString = value.toString().substring(0, 6);
                            }else{
                                tempString = value.toString().substring(0, 5);
                            }
                            jCurrTemp.setText(tempString);
                            if (jMaxTemp.getText().equals("-")) {
                                jMaxTemp.setText("-1000");
                            }
                            currMax = Double.parseDouble(jMaxTemp.getText());
                            if (jMinTemp.getText().equals("-")) {
                                jMinTemp.setText("1000");
                            }
                            currMin = Double.parseDouble(jMinTemp.getText());
                            if (value > currMax) {
                                if (value >= 100) {
                                    jMaxTemp.setText(value.toString().substring(0, 6));
                                }else{
                                    jMaxTemp.setText(value.toString().substring(0, 5));
                                }
                            }
                            if ((value < currMin)) {
                                if (value >= 100) {
                                    jMinTemp.setText(value.toString().substring(0, 6));
                                }else{
                                    jMinTemp.setText(value.toString().substring(0, 5));
                                }
                            }
                            if (mLogData.getState() == true) {
                                //jtaInput.append("Saving Data\n");
                                storeData(tempString, 1);
                            }
                            if (plotData == 1) {
                                if (plot != null) {
                                    plot.addData(tempString);
                                }
                            }
                            //if (trayIsThere == 1) {
                            //    trayIsThere = tray1.removeIcon();
                            //    trayIsThere = tray1.tryIcon("25");
                            //tray.
                            //tray.remove(icon);
//                                System.out.println("Tray value " + tray.toString());
//                                Dimension size = tray.getTrayIconSize();
//                                BufferedImage bi = new BufferedImage(size.width, size.height, BufferedImage.TYPE_INT_RGB);
//                                Graphics g = bi.getGraphics();
//                                g.setColor(Color.blue);
//                                g.fillRect(0, 0, size.width, size.height);
//                                g.setColor(Color.yellow);
//                                g.drawString("25", 1, 12);
//                                
//                                icon = null;
//                                tray.add(icon = new TrayIcon(bi));
                            //System.out.println("Tray icon added " + icon.toString());
                            //}
                        } catch (Exception e) {
                        }
                    }
                } catch (IOException e) {
                //System.out.println("error 7");
                }
                break;
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jCurrentTemp = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jCurrTemp = new javax.swing.JLabel();
        jCurrentTemp1 = new javax.swing.JLabel();
        jCurrentTemp2 = new javax.swing.JLabel();
        jMaxTemp = new javax.swing.JLabel();
        jMinTemp = new javax.swing.JLabel();
        jTime = new javax.swing.JTextField();
        jSeconds = new javax.swing.JLabel();
        jLogFileName = new javax.swing.JLabel();
        jtfFileName = new javax.swing.JTextField();
        jPlot = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jText = new javax.swing.JTextArea();
        jLogging = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        mLogData = new javax.swing.JCheckBoxMenuItem();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jRBmeasure = new javax.swing.JRadioButtonMenuItem();
        jRBstop = new javax.swing.JRadioButtonMenuItem();
        jRBstream = new javax.swing.JRadioButtonMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jrbC = new javax.swing.JRadioButtonMenuItem();
        jrbF = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem1 = new javax.swing.JRadioButtonMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        jlComPort = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();

        mainPanel.setMaximumSize(new java.awt.Dimension(385, 340));
        mainPanel.setMinimumSize(new java.awt.Dimension(385, 340));
        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.setOpaque(false);
        mainPanel.setPreferredSize(new java.awt.Dimension(385, 340));
        mainPanel.setRequestFocusEnabled(false);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(Measure.DIRECTEMP_TM.class).getContext().getResourceMap(DIRECTEMP_View.class);
        jCurrentTemp.setFont(resourceMap.getFont("jCurrentTemp.font")); // NOI18N
        jCurrentTemp.setText(resourceMap.getString("jCurrentTemp.text")); // NOI18N
        jCurrentTemp.setName("jCurrentTemp"); // NOI18N

        jPanel2.setBackground(resourceMap.getColor("jPanel2.background")); // NOI18N
        jPanel2.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jPanel2.setForeground(resourceMap.getColor("jPanel2.foreground")); // NOI18N
        jPanel2.setName("jPanel2"); // NOI18N

        jCurrTemp.setBackground(resourceMap.getColor("jCurrTemp.background")); // NOI18N
        jCurrTemp.setFont(resourceMap.getFont("jCurrTemp.font")); // NOI18N
        jCurrTemp.setForeground(resourceMap.getColor("jCurrTemp.foreground")); // NOI18N
        jCurrTemp.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jCurrTemp.setIcon(resourceMap.getIcon("jCurrTemp.icon")); // NOI18N
        jCurrTemp.setText(resourceMap.getString("jCurrTemp.text")); // NOI18N
        jCurrTemp.setName("jCurrTemp"); // NOI18N

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jCurrTemp, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(23, 23, 23)
                .add(jCurrTemp, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 79, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(23, Short.MAX_VALUE))
        );

        jCurrentTemp1.setFont(resourceMap.getFont("jCurrentTemp1.font")); // NOI18N
        jCurrentTemp1.setText(resourceMap.getString("jCurrentTemp1.text")); // NOI18N
        jCurrentTemp1.setName("jCurrentTemp1"); // NOI18N

        jCurrentTemp2.setFont(resourceMap.getFont("jCurrentTemp2.font")); // NOI18N
        jCurrentTemp2.setText(resourceMap.getString("jCurrentTemp2.text")); // NOI18N
        jCurrentTemp2.setName("jCurrentTemp2"); // NOI18N

        jMaxTemp.setFont(resourceMap.getFont("jMaxTemp.font")); // NOI18N
        jMaxTemp.setText(resourceMap.getString("jMaxTemp.text")); // NOI18N
        jMaxTemp.setName("jMaxTemp"); // NOI18N

        jMinTemp.setFont(resourceMap.getFont("jMinTemp.font")); // NOI18N
        jMinTemp.setText(resourceMap.getString("jMinTemp.text")); // NOI18N
        jMinTemp.setName("jMinTemp"); // NOI18N

        jTime.setText(resourceMap.getString("jTime.text")); // NOI18N
        jTime.setName("jTime"); // NOI18N
        jTime.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TimeDelay(evt);
            }
        });

        jSeconds.setText(resourceMap.getString("jSeconds.text")); // NOI18N
        jSeconds.setName("jSeconds"); // NOI18N

        jLogFileName.setText(resourceMap.getString("jLogFileName.text")); // NOI18N
        jLogFileName.setAutoscrolls(true);
        jLogFileName.setName("jLogFileName"); // NOI18N

        jtfFileName.setEditable(false);
        jtfFileName.setText(resourceMap.getString("jtfFileName.text")); // NOI18N
        jtfFileName.setName("jtfFileName"); // NOI18N
        jtfFileName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FileSaver(evt);
            }
        });

        jPlot.setText(resourceMap.getString("jPlot.text")); // NOI18N
        jPlot.setName("jPlot"); // NOI18N
        jPlot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Plot(evt);
            }
        });

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jText.setColumns(20);
        jText.setRows(5);
        jText.setName("jText"); // NOI18N
        jScrollPane1.setViewportView(jText);

        jLogging.setText(resourceMap.getString("jLogging.text")); // NOI18N
        jLogging.setName("jLogging"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        org.jdesktop.layout.GroupLayout mainPanelLayout = new org.jdesktop.layout.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jCurrentTemp)
                    .add(mainPanelLayout.createSequentialGroup()
                        .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(mainPanelLayout.createSequentialGroup()
                                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jCurrentTemp1)
                                    .add(jCurrentTemp2))
                                .add(16, 16, 16)
                                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jMinTemp, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 199, Short.MAX_VALUE)
                                    .add(jMaxTemp, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 199, Short.MAX_VALUE)))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, mainPanelLayout.createSequentialGroup()
                                .add(10, 10, 10)
                                .add(jTime, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 42, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jSeconds)
                                .add(62, 62, 62)
                                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLogging, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 144, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(mainPanelLayout.createSequentialGroup()
                                        .add(jLogFileName)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(jtfFileName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 143, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                        .add(118, 118, 118))
                    .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .add(37, 37, 37))
            .add(mainPanelLayout.createSequentialGroup()
                .add(99, 99, 99)
                .add(jPlot, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 166, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(120, Short.MAX_VALUE))
            .add(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel2)
                .addContainerGap(325, Short.MAX_VALUE))
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mainPanelLayout.createSequentialGroup()
                .add(jCurrentTemp)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(24, 24, 24)
                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jCurrentTemp1)
                    .add(jMaxTemp))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jCurrentTemp2)
                    .add(jMinTemp))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLogFileName)
                    .add(jTime, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jSeconds)
                    .add(jtfFileName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(5, 5, 5)
                .add(jLogging)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPlot, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(11, 11, 11)
                .add(jLabel2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 104, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(25, 25, 25))
        );

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        mLogData.setText(resourceMap.getString("mLogData.text")); // NOI18N
        mLogData.setName("mLogData"); // NOI18N
        mLogData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                LogToFileONOFF(evt);
            }
        });
        fileMenu.add(mLogData);

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(Measure.DIRECTEMP_TM.class).getContext().getActionMap(DIRECTEMP_View.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        jMenu2.setText(resourceMap.getString("jMenu2.text")); // NOI18N
        jMenu2.setName("jMenu2"); // NOI18N

        buttonGroup1.add(jRBmeasure);
        jRBmeasure.setSelected(true);
        jRBmeasure.setText(resourceMap.getString("jRBmeasure.text")); // NOI18N
        jRBmeasure.setName("jRBmeasure"); // NOI18N
        jRBmeasure.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MeasureData(evt);
            }
        });
        jMenu2.add(jRBmeasure);

        buttonGroup1.add(jRBstop);
        jRBstop.setText(resourceMap.getString("jRBstop.text")); // NOI18N
        jRBstop.setName("jRBstop"); // NOI18N
        jRBstop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StopData(evt);
            }
        });
        jMenu2.add(jRBstop);

        buttonGroup1.add(jRBstream);
        jRBstream.setText(resourceMap.getString("jRBstream.text")); // NOI18N
        jRBstream.setName("jRBstream"); // NOI18N
        jRBstream.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StreamData(evt);
            }
        });
        jMenu2.add(jRBstream);

        menuBar.add(jMenu2);

        jMenu1.setText(resourceMap.getString("jMenu1.text")); // NOI18N
        jMenu1.setName("jMenu1"); // NOI18N

        buttonGroup2.add(jrbC);
        jrbC.setSelected(true);
        jrbC.setText(resourceMap.getString("jrbC.text")); // NOI18N
        jrbC.setName("jrbC"); // NOI18N
        jrbC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TempCelcius(evt);
            }
        });
        jMenu1.add(jrbC);

        buttonGroup2.add(jrbF);
        jrbF.setText(resourceMap.getString("jrbF.text")); // NOI18N
        jrbF.setName("jrbF"); // NOI18N
        jrbF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TempF(evt);
            }
        });
        jMenu1.add(jrbF);

        buttonGroup2.add(jRadioButtonMenuItem1);
        jRadioButtonMenuItem1.setText(resourceMap.getString("jRadioButtonMenuItem1.text")); // NOI18N
        jRadioButtonMenuItem1.setName("jRadioButtonMenuItem1"); // NOI18N
        jRadioButtonMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                unitsK(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem1);

        jMenuItem1.setAction(actionMap.get("PortReset")); // NOI18N
        jMenuItem1.setText(resourceMap.getString("Port Reset.text")); // NOI18N
        jMenuItem1.setEnabled(false);
        jMenuItem1.setName("Port Reset"); // NOI18N
        jMenu1.add(jMenuItem1);

        jMenuItem2.setAction(actionMap.get("ResetMaxMin")); // NOI18N
        jMenuItem2.setText(resourceMap.getString("jMenuItem2.text")); // NOI18N
        jMenuItem2.setName("jMenuItem2"); // NOI18N
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem2);

        menuBar.add(jMenu1);

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setText(resourceMap.getString("aboutMenuItem.text")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showAboutBox(evt);
            }
        });
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        jlComPort.setText(resourceMap.getString("jlComPort.text")); // NOI18N
        jlComPort.setName("jlComPort"); // NOI18N

        jLabel1.setText(resourceMap.getString("jlSerialLabel.text")); // NOI18N
        jLabel1.setName("jlSerialLabel"); // NOI18N

        org.jdesktop.layout.GroupLayout statusPanelLayout = new org.jdesktop.layout.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .add(27, 27, 27)
                .add(jlComPort)
                .add(180, 180, 180)
                .add(statusMessageLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(statusAnimationLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 17, Short.MAX_VALUE)
                .addContainerGap())
            .add(statusPanelSeparator, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 385, Short.MAX_VALUE)
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(statusPanelLayout.createSequentialGroup()
                .add(2, 2, 2)
                .add(statusPanelSeparator, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(statusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(statusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                        .add(statusPanelLayout.createSequentialGroup()
                            .add(statusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(jlComPort))
                            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                        .add(statusPanelLayout.createSequentialGroup()
                            .add(statusMessageLabel)
                            .add(9, 9, 9)))
                    .add(statusAnimationLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
        addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                formPropertyChange(evt);
            }
        });
    }// </editor-fold>//GEN-END:initComponents
    /**Menu item to reset max/min
     * 
     * @param evt
     */
    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        jMaxTemp.setText("-");
        jMinTemp.setText("-");
    }//GEN-LAST:event_jMenuItem2ActionPerformed
   /**Timer for serial read and write timing
     * stop the read thread, set timer and restart it.  Not sure if this actually works...
     */
    private void TimeDelay(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TimeDelay
        //jtaInput.append("pushed time button \n");
        jSeconds.setEnabled(true);
        //jbTimed.setEnabled(false);
        //jSingle.setEnabled(false);
        //jbStream.setEnabled(false);
        jTime.setEnabled(true);
        jRBmeasure.setSelected(true);
        if (readTimer.isRunning()) {
            //jtaInput.append("Timer ON ....");
            readTimer.stop();
        //jtaInput.append("Timer OFF \n");
        }
        //jtaInput.append("Timer OK \n");
        readTimer.setDelay(Integer.valueOf(jTime.getText()) * 1000);
        readTimer.start();
    //jtaInput.append("Timer begins \n");
    }//GEN-LAST:event_TimeDelay
    /**TempCelcius
     * changes display to celcius (native device output)
     * resets the max and min temperature indicators
     * resets the plot (if on)
     * @param evt
     */
    private void TempCelcius(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TempCelcius
        uNits = 0;
        jCurrentTemp.setText("Current Temperature (C):");
        jMaxTemp.setText("-");
        jMinTemp.setText("-");
        uNit = "C";
        if (plot.isVisible()) {
            Plot(null);
        }
    //jtaInput.append("uNits = " + uNits.toString() + " (C) \n");
    }//GEN-LAST:event_TempCelcius
    /**
     * TempF
     * changes display to Fahrenheit by calculation in serial read
     * resets the max and min temperature indicators
     * resets the plot (if on)
     */
    private void TempF(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TempF
        uNits = 1;
        jCurrentTemp.setText("Current Temperature (F):");
        jMaxTemp.setText("-");
        jMinTemp.setText("-");
        uNit = "F";
        if (plot.isVisible()) {
            Plot(null);
        }
    //jtaInput.append("uNits = " + uNits.toString() + " (F) \n");
    }//GEN-LAST:event_TempF
    /**Log To File
     * create a filename
     * open a file outputstream for a printstream to send data to file
     * show filename on form
     */
    private void LogToFileONOFF(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_LogToFileONOFF
        if (mLogData.getState() == true){
            filename = SelectLogFile();
            try{
                if(!filename.exists()){
                    try{
                    filename.createNewFile();
                    }catch(Exception E){}
                }
                try{
                    fo = new FileOutputStream(filename);
                }catch(Exception e){}//fo = new FileOutputStream(filename);
                ps=new PrintStream(fo);
                //jtaInput.append("ready to log\n");
                //String unit = "(C)";
                //if (uNits == 1) {
                //    unit = "(F)";
                //}
                header = ("Comments:," + jText.getText());
                storeData(header,0);
                header = ("Date, Time, Temperature, " + uNit);
                //jtaInput.append(header + "\n");
                totalTime = 0;
                storeData(header,0);
                jtfFileName.setText(filename.getAbsolutePath());
                jLogFileName.setVisible(true);
                jtfFileName.setVisible(true);
                //jLogging.setVisible(false);
                jLogging.setVisible(true);
            }catch(Exception ex){}
        }else{
            try{
                ps.close();
                fo.close();
                jLogFileName.setVisible(false);
                jtfFileName.setVisible(false);
                jLogging.setVisible(false);
            }catch(Exception ex){}
        }
    }//GEN-LAST:event_LogToFileONOFF
    /**FileSaver
     * action from button calls previous
     */
    private void FileSaver(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FileSaver
        SelectLogFile();
    //filename = new File(jtfFileName.getText());
    }//GEN-LAST:event_FileSaver
    /**Build the plot window.  Check for units for title bar
     * pack in the components
     * Center the form
     * turn it on
     * set the close operation to not close the entire program
     * set the plot data flag so data will be sent to the plot
     */
    private void Plot(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Plot
        if (plotData == 1) {
            if (plot.isShowing()) {
                plot.dispose();
            }
        }
        if (uNits == 0) {
            plot = new LineChart("Temperature Plot (degree C vs. time)");
        }
        if (uNits == 1) {
            plot = new LineChart("Temperature Plot (degree F vs. time)");
        }
        if (uNits == 2) {
            plot = new LineChart("Temperature Plot (Kelvin vs. time)");
        }
        DIRECTEMP_TM.getApplication().show(plot);
        plot.pack();
        RefineryUtilities.centerFrameOnScreen(plot);
        //plot.setDefaultCloseOperation(plot.HIDE_ON_CLOSE);
        plotData = 1;   
    }//GEN-LAST:event_Plot
    /**
     * Show the about box... need new graphic for it.
     */
    private void showAboutBox(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showAboutBox
        if (aboutBox == null) {
            JFrame mainFrame = DIRECTEMP_TM.getApplication().getMainFrame();
            aboutBox = new DIRECTEMP_AboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        DIRECTEMP_TM.getApplication().show(aboutBox);
    
}//GEN-LAST:event_showAboutBox
/**set the form size if it is resized... lock it down
 * --- doesn't work though -----
  */
    private void formPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_formPropertyChange
        this.jPanel2.setSize(385, 340);
        this.statusPanel.setSize(385,340);
        this.getFrame().getSize();
        this.getFrame().setSize(385,340);
    }//GEN-LAST:event_formPropertyChange
/**
 * send "1" to device for streaming temperature from device
 * Stream data asks device for data as fast as it can send it.  12 points / sec max
 * must send x character to end this mode
 * @param evt
 */
    private void StreamData(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StreamData
        jRBstop.setEnabled(true);
        jTime.setEnabled(false);
        jSeconds.setEnabled(false);
        //jSingle.setEnabled(false);
        try {
            oS.write("1".getBytes());
            //jtaInput.append("Stream\n");
        } catch (IOException e) {
        }
    }//GEN-LAST:event_StreamData
/**
 * stop data stops the timer if in measure mode or sends the x to stop the stream if running
 * it also greys out the stop menu option that is enabled when starting mesure or stream
 * @param evt
 */
    private void StopData(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StopData
        jTime.setEnabled(true);
        jSeconds.setEnabled(true);
        try {
            oS.write("x".getBytes());
        } catch (IOException e) {
        }  
        if (readTimer.isRunning()) {
            readTimer.stop();
            //readTimer.start();
        }
        jRBstop.setEnabled(false);
        jRBstop.setSelected(false);
        
    }//GEN-LAST:event_StopData
/** MeasureData - menu command to start data request from device
     * if off, switch on, if on, switch off.
     * 
    */
    private void MeasureData(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MeasureData
        jRBstop.setEnabled(true);
        TimeDelay(null);
    }//GEN-LAST:event_MeasureData
/** set units to kelvin
 * set unit value to 3 for kelvin display
 * @param evt
 */
    private void unitsK(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_unitsK
        uNits = 2;
        jCurrentTemp.setText("Current Temperature (K):");
        jMaxTemp.setText("-");
        jMinTemp.setText("-");
        uNit = "K";
        if (plot.isVisible()) {
            Plot(null);
        }
    }//GEN-LAST:event_unitsK
    /**Store data to a file
     * store a string with the current date and time along with a counter and the data
     * 
     * 
     */
    @Action
    public void storeData(String temp, int mode) {
        String DATE_FORMAT_NOW = "MM/dd/yyy,HH:mm:ss";
        Calendar cal = Calendar.getInstance();
        SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
        sdf.format(cal.getTime());
        if (mode == 0){ // header write
            ps.println(header);
        }else{
            
            //temp = sdf.toString() + "," + totalTime.toString() + "," + temp;
            
            temp = sdf.format(cal.getTime()) + "," + temp + "," + uNit;
            ps.println(temp);
            //jtaInput.append(temp);
            //ps.println(tf02.getText());
            // total time is an incremented integer for numbering output lines
            totalTime = totalTime + Integer.valueOf(jTime.getText());
        }  
    }
    /**Single data point
     * collect a single point of data
     */
    @Action
    public void Single() {
        try {
            oS.write("2".getBytes());
        //jtaInput.append("Single\n");
        } catch (IOException e) {
        }
    }
    /**
     * reset the port must kill the thread to do so...
     * system always hangs when this runs... 
     * the port choosing box... all the serial stuff should be a separate object
     */
    @Action
    public void PortReset() {
        portReset = 1;
        myPort.close();
        PC = new SerialPortSelect(null); // create port chooser window
        PC.setVisible(true); // show port chooser window
        jlComPort.setText(PC.getSelectedName()); // set com port name in panel
        //PC.addSerialPortListener(SerialPortListener); // turn on port and open listener
        try {
            thePort = thePortID.open("sysDataComm", 30000);
            myPort = (SerialPort) thePort;
        //jtaInput.append("Port Active\n");
        } catch (PortInUseException e) {
        }
        try {
            is = myPort.getInputStream();
        //jtaInput.append("Input selected\n");
        } catch (IOException e) {
        }
        try {
            // get the outputstream
            oS = myPort.getOutputStream();
        //jtaInput.append("Output selected\n");
        } catch (IOException e) {
        }
        //try {
        //    oS.write(out1.getBytes());
        //} catch (IOException e) {}//        try {
        try {
            portReset = 0;
            myPort.addEventListener(this);
        } catch (TooManyListenersException e) {
            System.out.println("error 3");
        }
        thePortID = PC.getSelectedIdentifier();
    }
    /**Select a log file
     * sets up the save dialog to use to either choose or create new file
     * calls filename global to set the file name. 
     */
    @Action
    public File SelectLogFile() {
        String wd = System.getProperty("user.dir");
        //JFileChooser fc = new JFileChooser(new File(filename));
        JFileChooser fc = new JFileChooser(wd);
        String fn;
        //fc.
        int rc = fc.showSaveDialog(null);//"Select Data File");
        if (rc == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            if (fc.getSelectedFile().equals(null)) {
                filename = new File(jtfFileName.getText());
            //jtaInput.append(file.toString());
            }
            fn = file.getAbsolutePath();
            filename = file;
            //jtaInput.append(filename + "chosen for logging data");
            //jLogFileName.setText("Log File: " + fc.getName());
            return (file);
        } else {
        //jtaInput.append("File chooser cancel button clicked");
        }
        return (null);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    public javax.swing.JLabel jCurrTemp;
    private javax.swing.JLabel jCurrentTemp;
    private javax.swing.JLabel jCurrentTemp1;
    private javax.swing.JLabel jCurrentTemp2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    public javax.swing.JLabel jLogFileName;
    private javax.swing.JLabel jLogging;
    public javax.swing.JLabel jMaxTemp;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    public javax.swing.JLabel jMinTemp;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton jPlot;
    private javax.swing.JRadioButtonMenuItem jRBmeasure;
    private javax.swing.JRadioButtonMenuItem jRBstop;
    private javax.swing.JRadioButtonMenuItem jRBstream;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel jSeconds;
    private javax.swing.JTextArea jText;
    private javax.swing.JTextField jTime;
    public javax.swing.JLabel jlComPort;
    private javax.swing.JRadioButtonMenuItem jrbC;
    private javax.swing.JRadioButtonMenuItem jrbF;
    private javax.swing.JTextField jtfFileName;
    private javax.swing.JCheckBoxMenuItem mLogData;
    private static javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables
    //private final Timer messageTimer;
    //private final Timer busyIconTimer;
    //private final Icon idleIcon;
    //private final Icon[] busyIcons = new Icon[15];
    //private int busyIconIndex = 0;
    private JDialog aboutBox;
    private JDialog plotPanel;
}
/**
 * Choose a port, any port!
 *
 * Java Communications is a "standard extension" and must be downloaded
 * and installed separately from the JDK before you can even compile this
 * program.
 *
 */
class SerialPortSelect extends JDialog implements ItemListener {

    /** A mapping from names to CommPortIdentifiers. */
    protected HashMap map = new HashMap();
    /** The name of the choice the user made. */
    protected String selectedPortName;
    /** The CommPortIdentifier the user chose. */
    protected CommPortIdentifier selectedPortIdentifier;
    /** The JComboBox for serial ports */
    protected JComboBox serialPortsChoice;
    /** The JComboBox for parallel ports */
    protected JComboBox other;
    /** The SerialPort object */
    protected SerialPort ttya;
    /** To display the chosen */
    protected JLabel choice;
    /** Padding in the GUI */
    protected final int PAD = 5;
    /** This will be called from either of the JComboBoxes when the
     * user selects any given item.*/
    public void itemStateChanged(ItemEvent e) {
        // Get the name
        selectedPortName = (String) ((JComboBox) e.getSource()).getSelectedItem();
        // Get the given CommPortIdentifier
        selectedPortIdentifier = (CommPortIdentifier) map.get(selectedPortName);
        // Display the name.
        choice.setText(selectedPortName);
    }
    /* The public "getter" to retrieve the chosen port by name. */
    public String getSelectedName() {
        return selectedPortName;
    }
    /* The public "getter" to retrieve the selection by CommPortIdentifier. */
    public CommPortIdentifier getSelectedIdentifier() {
        return selectedPortIdentifier;
    }
    /** Construct a Port selector --make the window and add ports.
     */
    public SerialPortSelect(JFrame parent) {
        super(parent, "Select Port", true);
        makeGUI();
        populate();
        finishGUI();
    }
    protected void makeGUI() {
        Container cp = getContentPane();
        JPanel centerPanel = new JPanel();
        cp.add(BorderLayout.CENTER, centerPanel);
        centerPanel.setLayout(new GridLayout(0, 2, PAD, PAD));
        centerPanel.add(new JLabel("Serial Port", JLabel.RIGHT));
        serialPortsChoice = new JComboBox();
        centerPanel.add(serialPortsChoice);
        serialPortsChoice.setEnabled(false);
        centerPanel.add(new JLabel("Your choice:", JLabel.RIGHT));
        centerPanel.add(choice = new JLabel());
        JButton okButton;
        cp.add(BorderLayout.SOUTH, okButton = new JButton("OK"));
        okButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                SerialPortSelect.this.dispose();
            }
        });
    }
    /** Populate the ComboBoxes by asking the Java Communications API
     * what ports it has. Since the initial information comes from
     * a Properties file, it may not exactly reflect your hardware.
     */
    protected void populate() {
        // get list of ports available on this particular computer,
        // by calling static method in CommPortIdentifier.
        Enumeration pList = CommPortIdentifier.getPortIdentifiers();
        // Process the list, putting serial and parallel into ComboBoxes
        while (pList.hasMoreElements()) {
            CommPortIdentifier cpi = (CommPortIdentifier) pList.nextElement();
            // System.out.println("Port " + cpi.getName());
            map.put(cpi.getName(), cpi);
            if (cpi.getPortType() == CommPortIdentifier.PORT_SERIAL) {
                serialPortsChoice.setEnabled(true);
                serialPortsChoice.addItem(cpi.getName());
            }
        }
        serialPortsChoice.setSelectedIndex(-1);
    }
    protected void finishGUI() {
        serialPortsChoice.addItemListener(this);
        pack();
    }
}
class LineChart extends JFrame {

    /** The time series data. */
    private TimeSeries series;
    /** The most recent value added. */
    private double lastValue = 100.0;
    /**
     * Constructs a new demonstration application.
     *
     * @param title  the frame title.
     */
    public LineChart(final String title) {
        super(title);
        this.series = new TimeSeries("Temperature", Millisecond.class);
        final TimeSeriesCollection dataset = new TimeSeriesCollection(this.series);
        final JFreeChart chart = createChart(dataset);
        final ChartPanel chartPanel = new ChartPanel(chart);
        final JPanel content = new JPanel(new BorderLayout());
        //final JComboBox autoScale = new JComboBox();
        content.add(chartPanel);
        //content.add(autoScale);
        chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
        setContentPane(content);
    //chartPanel.doSaveAs();   
    }
    /**
     * Creates a sample chart.
     * 
     * @param dataset  the dataset.
     * 
     * @return A sample chart.
     */
    private JFreeChart createChart(final XYDataset dataset) {
        final JFreeChart result = ChartFactory.createTimeSeriesChart(
                "Temperature Plot",
                "Time",
                "Temperature",
                dataset,
                true,
                true,
                false);
        final XYPlot plot = result.getXYPlot();
        ValueAxis axis = plot.getDomainAxis();
        axis.setAutoRange(true);
        axis.setFixedAutoRange(300000.0);  // 300 seconds = 5 min
        axis = plot.getRangeAxis();
        axis.setRange(0.0, 80.0);
        return result;
    }
    /**
     * Handles a click on the button by adding new (random) data.
     *
     * @param e  the action event.
     */
    public void addData(String temp) {
        //final double factor = 0.90 + 0.2 * Math.random();
        this.lastValue = Double.valueOf(temp);
        final Millisecond now = new Millisecond();
        //System.out.println("Now = " + now.toString());
        this.series.add(new Millisecond(), this.lastValue);
    }
}
//class SystemTray extends {
//public SystemTray() throws Exception {
//    if (!SystemTray.isSupported()) {
//      return;
//    }
//    SystemTray tray = SystemTray.getSystemTray();
//
//    PropertyChangeListener pcl;
//    pcl = new PropertyChangeListener() {
//      public void propertyChange(PropertyChangeEvent pce) {
//        System.out.println("Property changed = " + pce.getPropertyName());
//        TrayIcon[] tia = (TrayIcon[]) pce.getOldValue();
//        if (tia != null) {
//          System.out.println("Old tray icon array contents: ");
//          for (int i = 0; i < tia.length; i++)
//            System.out.println(tia[i]);
//          System.out.println();
//        }
//
//        tia = (TrayIcon[]) pce.getNewValue();
//        if (tia != null) {
//          System.out.println("New tray icon array contents: ");
//          for (int i = 0; i < tia.length; i++)
//            System.out.println(tia[i]);
//          System.out.println();
//        }
//      }
//    };
//    tray.addPropertyChangeListener("trayIcons", pcl);
//
//    Dimension size = tray.getTrayIconSize();
//    BufferedImage bi = new BufferedImage(size.width, size.height, BufferedImage.TYPE_INT_RGB);
//    Graphics g = bi.getGraphics();
//
//    g.setColor(Color.blue);
//    g.fillRect(0, 0, size.width, size.height);
//    g.setColor(Color.yellow);
//    g.drawString("25", 1, 12);
//    TrayIcon icon = null;
//    tray.add(icon = new TrayIcon(bi));
//
//    Thread.sleep(3000);
//    tray.remove(icon);
//
//    Thread.sleep(3000);
//    System.exit(0);
//  }
//
//}
class TraysIcon {

    Integer trayIs;
    public SystemTray tray;
    public TrayIcon icon;

    public TraysIcon() {

    }
    public Integer tryIcon(String currTemp) {
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        if (!SystemTray.isSupported()) {
            tray = SystemTray.getSystemTray();
        } else {
            tray = null;
            return (0);
        }
        //Image image = toolkit.getImage("trayIcon.jpg");

        PopupMenu pmenu = new PopupMenu();

        trayIs = 1;
        Dimension size = tray.getTrayIconSize();
        BufferedImage bi = new BufferedImage(size.width, size.height, BufferedImage.TYPE_INT_RGB);
        Graphics g = bi.getGraphics();

        g.setColor(Color.blue);
        g.fillRect(0, 0, size.width, size.height);
        g.setColor(Color.yellow);
        g.drawString(currTemp, 1, 13);

        MenuItem messageItem = new MenuItem("Show Message");
        messageItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                JOptionPane.showMessageDialog(null, "Program Minimized");
            }
        });
        pmenu.add(messageItem);

        MenuItem closeItem = new MenuItem("Close");
        closeItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                removeIcon();
            //restoreForm();
            }
        });
        pmenu.add(closeItem);
        //TrayIcon icon = new TrayIcon(image, "SystemTray Demo", menu);
        //icon.setImageAutoSize(true);

        //tray.add(icon);
        icon = null;
        try {
            tray.add(icon = new TrayIcon(bi, "QTI USB Temperature", pmenu));
        } catch (AWTException a) {
            trayIs = 0;
            return (0);
        }
        trayIs = 1;
        return (trayIs);
    }
    public Integer removeIcon() {
        if (trayIs == 1) {
            tray.remove(icon);
        }
        trayIs = 0;
        return (trayIs);
    }
}
